/*=============================================================================
	Vertexshader for DrawComplexSurface, hardware lights, FogMap.
	Experimental, unfinished, broken, unusable. Currently not in use.

	Revision history:
		* Created by Smirftsch
=============================================================================*/

layout (location = 0) in vec3 v_coord;		// == gl_Vertex
layout (location = 1) in vec3 v_normal;
layout (location = 2) in vec2 TexCoords;

uniform mat3 m_3x3_inv_transp;				// == gl_NormalMatrix inverse transpose of modelviewMat
uniform mat4 projMat;
uniform mat4 viewMat;
uniform mat4 modelMat;
uniform mat4 modelviewMat;
uniform mat4 viewMatinv;					// == ViewMatrix inverse

layout(std140) uniform GlobalMatrices
{
	mat4 modelviewprojMat;
	mat4 modelviewMat;
};


out vec2 vTexCoords;
out vec2 vLightTexCoords;
out vec3 vv_coord;
out vec3 vv_normal;
out vec3 vNormalDirection;

out mat4 vmodelMat;
/*
out mat3 vm_3x3_inv_transp;
out mat4 vprojMat;
out mat4 vviewMat;
out mat4 vmodelviewMat;
out mat4 vmodelviewprojMat;
out mat4 vviewMatinv;
*/

void main(void)
{
	//pass matrix also to fragment shader
	vmodelMat			= modelMat;
	/*
	vprojMat			= projMat;
	vviewMat			= viewMat;
	vmodelviewMat		= modelviewMat;
	vmodelviewprojMat	= modelviewprojMat;
	vm_3x3_inv_transp	= m_3x3_inv_transp;
	vviewMatinv			= viewMatinv;
	*/
	vv_coord			= v_coord;
	vv_normal			= v_normal;

	//Texture UV to fragment
	vTexCoords=TexCoords;

	vNormalDirection = m_3x3_inv_transp * v_normal;
	gl_Position = modelviewprojMat * vec4(v_coord, 1.0);
}
