/*=============================================================================
	Fragmentshader for DrawSimple, line drawing.

	Revision history:
		* Created by Smirftsch
=============================================================================*/

uniform vec4 DrawColor;
uniform uint LineFlags;
uniform bool bHitTesting;

in float texCoord;

// LineFlags
const uint LINE_None			= 0x00u;
const uint LINE_Transparent		= 0x01u;
const uint LINE_DepthCued	 	= 0x02u;

out vec4 FragColor;

void main(void)
{
	vec4 TotalColor = DrawColor;

	if ( (LineFlags&LINE_Transparent)==LINE_Transparent )
	{
	}

	FragColor = TotalColor;
}
